//package com.wipro.servlet
/**
 * Date : 06-11-2006 Copyright 2006 Wipro, Ltd. All rights reserved. Wipro
 * PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import java.io.*;


import javax.servlet.*;
import javax.servlet.http.*;

import com.hp.hpl.jena.query.*;

import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.query.ResultSetFormatter;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.sparql.resultset.ResultSetFormat;

/**
 * @author akhilesh.laddha@wipro.com
 *
 */
public class queryExample4 extends HttpServlet
{
	private static final String CONTENT_TYPE = "text/html; charset=windows-1252";

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		
	}
 public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
	{
 doPost(request, response);
	}
	/**
	 * Process the HTTP doPost request.
	 */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException
	{
		

		try
		{
			InputStream in = new FileInputStream(new File("D:/example4.rdf"));
			OutputStream out = response.getOutputStream();

			// Create an empty in-memory model and populate it from the graph
			Model model = ModelFactory.createMemModelMaker().createModel();
			model.read(in,null); // null base URI, since model URIs are absolute
			in.close();

			// Create a new query
			String queryString = 
	           "PREFIX foaf:   <http://xmlns.com/foaf/0.1/> " +
				"PREFIX org:    <http://example.com/ns#>"+
				"SELECT ?EmpName ?Email ?address ?ContactNumber WHERE  { ?x foaf:name ?EmpName . ?x foaf:mbox ?Email . ?x foaf:address ?address . ?x foaf:contact ?ContactNumber}";

			
			Query query = QueryFactory.create(queryString);

			// Execute the query and obtain results
			QueryExecution qe = QueryExecutionFactory.create(query, model);
			ResultSet results = qe.execSelect();

			// Output query results	
			//ResultSetFormatter.out(System.out, results, query);
			
			//ResultSetFormatter.out(out, results, query);
			
			
			String stylesheet = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"+
			"<xsl:stylesheet version=\"1.0\"\n"+ 
			"xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"+
			"xmlns:spr=\"http://www.w3.org/2007/SPARQL/results#\">\n"+
			"<xsl:output method=\"html\" version=\"1.0\" encoding=\"UTF-8\" indent=\"yes\"/>\n"+
			"<xsl:template match=\"/\">\n"+
			         "<xsl:variable name=\"nvars\" select=\"count(//spr:variable)\"/>\n"+
			         "<xsl:variable name=\"nres\" select=\"count(//result)\"/>\n"+
			         "<xsl:element name=\"table\">\n"+
			         "<xsl:attribute name=\"border\">1</xsl:attribute>\n"+
			         "<xsl:element name=\"tr\">\n"+
			         "<xsl:element name=\"th\">\n"+
			         "<xsl:attribute name=\"colspan\">\n"+
			                 "<xsl:value-of select=\"$nvars\"/>\n"+
			         "</xsl:attribute>Results\n"+
			         "</xsl:element>\n"+
			         "</xsl:element>\n"+
			         "<xsl:element name=\"tr\">\n"+
			         "<xsl:for-each select=\"//spr:variable\">\n"+
			         "<xsl:element name=\"th\">\n"+
			                 "<xsl:value-of select=\"@empname\"/>\n"+
			         "</xsl:element>\n"+
			         "</xsl:for-each>\n"+
			         "</xsl:element>\n"+
			         "<xsl:for-each select=\"//spr:result\">\n"+
			                 "<xsl:element name=\"tr\">\n"+
			                 "<xsl:apply-templates/>\n"+
			                 "</xsl:element>\n"+
			         "</xsl:for-each>\n"+
			         "</xsl:element>\n"+
			"</xsl:template>\n"+
			"<xsl:template match=\"spr:binding\">\n"+
			         "<xsl:element name=\"td\">\n"+
			         "<xsl:copy-of select=\"child::node()/child::node()\"/>\n"+
			         "</xsl:element>\n"+
			"</xsl:template>\n"+
			"</xsl:stylesheet>";
			
		//String stylesheet_1 = stylesheet.substring(0, (stylesheet.length()-3));

		/*String stylesheet ="<?xml version='1.0' encoding='UTF-8'?><xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:ruleml='http://www.ruleml.org/0.9/xsd' xmlns:spr='http://www.w3.org/2007/SPARQL/results#'><xsl:output method='html' version='1.0' media-type='text/html' doctype-public='-//W3C//DTD HTML 4.01 Transitional//EN' encoding='UTF-8' indent='yes'/><xsl:template match='/'><xsl:variable name='nvars' select='count(//spr:variable)'/><xsl:variable name='nres' select='count(//result)'/><xsl:element name='table'><xsl:attribute name='border'>1</xsl:attribute><xsl:element name='tr'><xsl:element name='th'><xsl:attribute name='colspan'><xsl:value-of select='$nvars'/></xsl:attribute>Results</xsl:element></xsl:element><xsl:element name='tr'><xsl:for-each select='//spr:variable'><xsl:element name='th'><xsl:value-of select='@empname'/></xsl:element></xsl:for-each></xsl:element><xsl:for-each select='//spr:result'><xsl:element name='tr'><xsl:apply-templates/></xsl:element></xsl:for-each></xsl:element></xsl:template><xsl:template match='spr:binding'><xsl:element name='td'><xsl:copy-of select='child::node()/child::node()'/></xsl:element></xsl:template><xsl:template match='text()|@*'/></xsl:stylesheet>";*/

			System.out.println("stylesheet:::: "+stylesheet);

				ResultSetFormatter.outputAsXML(out, results, stylesheet);
			
			// Important - free up resources used running the query
			qe.close();
						
		}
		
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
}
